SystemOrganization addCategory: #Jejak!
SystemOrganization addCategory: #'Jejak-Tests'!
SystemOrganization addCategory: #'Jejak-Help'!

TestCase subclass: #JTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak-Tests'!

!JTests commentStamp: '<historical>' prior: 0!
This class contains code for testing the code analysis framework, a few interface examples and a method for overhead estimations (profiling)

!

!JTests methodsFor: 'displaying' stamp: 'ThierryGoubier 7/18/2012 10:26'!
displayCleanTraceCArleast5
	"Test tracing on the array."

	"JTests new displayCleanTraceCArleast5"

	JCollecteur recorder: JRecorder new.
	#(#rleast: #reorder: #least:array2:) 
		do: [:e | JVariableProbesWriter analyse: e in: JExampleArray].
	self testCArleast5.
	JLoopArrange do: JCollecteur recorder elements first value.
	JMethodArrange do: JCollecteur recorder elements first value.
	JViewer open.
	JProbesWriter uninstall.! !

!JTests methodsFor: 'displaying' stamp: 'ThierryGoubier 7/18/2012 10:26'!
displayMessageTraceCArleast5
	"Test tracing on the array."
	
	"JTests new displayMessageTraceCArleast5"

	JCollecteur recorder: JRecorder new.
	#(#rleast: #reorder: #least:array2:) 
		do: [:e | JCFGProbesWriter analyse: e in: JExampleArray].
	self testCArleast5.
	JViewer open.
	JProbesWriter uninstall.! !

!JTests methodsFor: 'displaying' stamp: 'ThierryGoubier 7/18/2012 10:26'!
displayTraceCArleast5
	"Test tracing on the array."
	
	"JTests new displayTraceCArleast5"

	JCollecteur recorder: JRecorder new.
	#(#rleast: #reorder: #least:array2:) 
		do: [:e | JVariableProbesWriter analyse: e in: JExampleArray].
	self testCArleast5.
	JViewer open.
	JProbesWriter uninstall.! !

!JTests methodsFor: 'profiling' stamp: 'ThierryGoubier 7/18/2012 10:09'!
overheadTraceCArleast5
	"Tracing overhead on the array least5 search."

	| var r |
	var := JExampleArray new: 31.
	r := Random new.
	1 to: var size do: [ :i | var at: i put: (r next * 15) rounded ].
	TimeProfiler onBlock: [ 10000 timesRepeat: [ var rleast: 5 ] ].
	JCollecteur recorder: JEmptyRecorder new.
	#(#rleast: #reorder: #least:array2:) do: [ :e | JCFGProbesWriter analyse: e in: JExampleArray ].
	TimeProfiler
		onBlock: [ 
			10000
				timesRepeat: [ 
					var rleast: 5.
					JCollecteur recorder reset ] ].
	JProbesWriter uninstall.
	JCollecteur recorder: JRecorder new! !

!JTests methodsFor: 'profiling' stamp: 'ThierryGoubier 7/18/2012 10:09'!
overheadTraceRecordingCArleast5
	"Tracing overhead with events recording on the array least5 search."

	| var r |
	var := JExampleArray new: 31.
	r := Random new.
	1 to: var size do: [ :i | var at: i put: (r next * 15) rounded ].
	TimeProfiler onBlock: [ 10000 timesRepeat: [ var rleast: 5 ] ].
	JCollecteur recorder: JRecorder new.
	#(#rleast: #reorder: #least:array2:) do: [ :e | JCFGProbesWriter analyse: e in: JExampleArray ].
	TimeProfiler
		onBlock: [ 
			10000
				timesRepeat: [ 
					var rleast: 5.
					JCollecteur recorder reset ] ].
	JProbesWriter uninstall.
	JCollecteur recorder: JRecorder new! !

!JTests methodsFor: 'profiling' stamp: 'ThierryGoubier 7/18/2012 10:09'!
overheadTraceVar2CArleast5
	"Tracing overhead on the array least5 search."
	
	"TestCodeAnalysis new overheadTraceVar2CArleast5"

	| var r |
	var := JExampleArray new: 31.
	r := Random new.
	1 to: var size do: [ :i | var at: i put: (r next * 15) rounded ].
	TimeProfiler onBlock: [ 10000 timesRepeat: [ var rleast: 5 ] ].
	JCollecteur recorder: JEmptyRecorder new.
	#(#rleast: #reorder: #least:array2:) do: [ :e | JCFGProbesWriterToVar analyse: e in: JExampleArray ].
	TimeProfiler
		onBlock: [ 
			10000
				timesRepeat: [ 
					var rleast: 5.
					JCollecteur recorder reset ] ].
	JProbesWriter uninstall.
	JCollecteur recorder: JRecorder new! !

!JTests methodsFor: 'profiling' stamp: 'ThierryGoubier 7/18/2012 10:09'!
overheadTraceVarCArleast5
	"Tracing overhead on the array least5 search."

	"TestCodeAnalysis new overheadTraceVarCArleast5"

	| var r |
	var := JExampleArray new: 31.
	r := Random new.
	1 to: var size do: [ :i | var at: i put: (r next * 15) rounded ].
	TimeProfiler onBlock: [ 10000 timesRepeat: [ var rleast: 5 ] ].
	JCollecteur recorder: JEmptyRecorder new.
	#(#rleast: #reorder: #least:array2:) do: [ :e | JCFGProbesWriter analyse: e in: JExampleArray ].
	TimeProfiler
		onBlock: [ 
			10000
				timesRepeat: [ 
					var rleast: 5.
					JCollecteur recorder reset ] ].
	JProbesWriter uninstall.
	JCollecteur recorder: JRecorder new! !

!JTests methodsFor: 'testing' stamp: 'ThierryGoubier 7/18/2012 10:07'!
testCArleast5
	"Test the CA array rleast search."

	| var r a v p |
	var := JExampleArray new: 31.
	r := Random new.
	1 to: var size do: [:i | var at: i put: (r next * 15) rounded].
	a := var rleast: 5.
	v := a first.
	p := a last.
	1 to: v size
		do: 
			[:i | 
			i + 1 to: v size
				do: 
					[:j | 
					self assert: (v at: i) <= (v at: j).
					(v at: i) = (v at: j) ifTrue: [self assert: (p at: i) < (p at: j)]].
			self assert: (var at: (p at: i)) = (v at: i)].
	1 to: var size - 1
		do: [:i | (var at: i) < v last ifTrue: [self assert: (p includes: i)]].! !

!JTests methodsFor: 'testing' stamp: 'ThierryGoubier 7/18/2012 10:07'!
testNodeFinder
	"Test finding a node in the AST."

	| n m |
	m := JExampleArray compiledMethodAt: #rleast:.
	n := JCodeNodeFinder find: 50 in: m.
	self assert: (n source copyFrom: n sourceInterval first to: n sourceInterval last) = 'ml + 1'! !

!JTests methodsFor: 'testing' stamp: 'ThierryGoubier 7/18/2012 10:09'!
testTraceCArleast5
	"Test tracing on the array."

	JCollecteur recorder: JRecorder new.
	#(#rleast: #reorder: #least:array2:) 
		do: [:e | JCFGProbesWriter analyse: e in: JExampleArray].
	self testCArleast5.
	JProbesWriter uninstall.
	JCollecteur recorder reset! !

!JTests methodsFor: 'testing' stamp: 'ThierryGoubier 7/18/2012 10:09'!
testTraceVariableCArleast5
	"Test tracing on the array."

	JCollecteur recorder: JRecorder new.
	#(#rleast: #reorder: #least:array2:) 
		do: [:e | JVariableProbesWriter analyse: e in: JExampleArray].
	self testCArleast5.
	JProbesWriter uninstall.
	JCollecteur recorder reset! !

!JTests methodsFor: 'testing' stamp: 'ThierryGoubier 7/18/2012 10:07'!
testTracerWriter
	"Test tracing on the array."

	JCFGProbesWriter analyse: #rleast: in: JExampleArray.
	JProbesWriter uninstall! !

Exception subclass: #JCodeNodeFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JCodeNodeFound commentStamp: 'ThierryGoubier 6/22/2012 15:06' prior: 0!
CodeFoundException is used to signal, when looking for a node, that we have found it.!

CustomHelp subclass: #JHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak-Help'!

!JHelp class methodsFor: 'accessing' stamp: 'ThierryGoubier 7/18/2012 11:10'!
bookName
	^ 'Jejak - A trace framework - Documentation'! !

!JHelp class methodsFor: 'pages' stamp: 'ThierryGoubier 7/18/2012 14:34'!
firstPage
	^ HelpTopic
		title: 'The Jejak Trace framework - Overview'
		contents: 'INTRODUCTION

During the VALMADEO project (a PRIR/Rgion Bretagne funded project directed by
C. Dezan, <dezan@univ-brest.fr>), we needed a tool to study in details how some
algorithms (error correcting codes) could work without errors, but with degraded
performance. Execution and compilation would report no errors, but the performance
of the error correcting coding and decoding would be several dB below the target.
The error correcting code was looping hundreds of times over each block of data,
making step by step debugging unusable. Profiling, message tallies were too coarse
to tell us anything. We needed a different tool.

The answer was this trace tool : a framework for injecting probes into methods, and
record their execution. It can record an execution to the smallest detail (all calls, all
values, all assignments), that over a long sequence (hundreds or thousands of calls),
and let one navigate freely through the recorded trace along with the traced source
code. It is capable of tracing system, startup or display methods, without interruption
or blocking the overall image, allowing for very fine non-intrusive system analysis.

It has been used for debugging turbo codes implementations, algorithm understanding
on turbo codes, and memory behavior analysis for embedded systems design space
exploration.

It was first implemented on VisualWorks 7.5 in 2007 by T. Goubier <thierry.goubier@gmail.com>,
then ported in 2012 to Pharo 1.4.'! !

!JHelp class methodsFor: 'pages' stamp: 'ThierryGoubier 7/18/2012 11:10'!
lastPage
	^ HelpTopic
		title: 'The Jejak Trace framework - References'
		contents: 'REFERENCES

T. Goubier, ValMadeo Project Report: The Trace and Dynamic Program Analysis Framework, August 27, 2007, UBO Technical Report.

Goubier, T.; Dezan, C.; Pottier, B.; Jego, C.; , "Fine grain parallel decoding of turbo product codes: Algorithm and architecture," Turbo Codes and Related Topics, 2008 5th International Symposium on , vol., no., pp.90-95, 1-5 Sept. 2008. doi: 10.1109/TURBOCODING.2008.4658678
'! !

!JHelp class methodsFor: 'pages' stamp: 'ThierryGoubier 6/29/2012 15:52'!
pages
	^ #(#firstPage #secondPage #thirdPage #lastPage)! !

!JHelp class methodsFor: 'pages' stamp: 'ThierryGoubier 10/7/2012 09:26'!
secondPage
	^ HelpTopic
		title: 'The Jejak Trace framework -  User Manual'
		contents: 'User Manual

1- GUI

The tracer gui is integrated under the Tools menu, at Jejak Trace Viewer.

The left pane shows the recorded event trace, the right pane is the source code
linked to an event selected in the right pane. Selecting an event on the left will
display the source code of the method which generated this event, and select the
statement of the event.

Three buttons allows to handle the tracer behavior:
- Erase Events : erase all recorded events.
- Remove Probes: remove all probes from all traced methods, revert them to the original source.
- Update: Update the list of events.

2- Probes

Probes are inserted by asking the tracer to analyse methods. This is done in the
system browser, by selecting a method and the command Toggle Trace. Once
this is done, the method will generate events as soon as it is executed (typically
by executing code in a workspace or a test case).

3- Usual use

- Choose a method (or a few methods) of interest.
- Toggle trace on those methods through a system browser.
- Run a few test cases.
- Open or Update the Trace Viewer to see the trace.
- Explore the trace.
- Remove the probes, erase the events and redo.

4- Example

- Toggle Trace on VTExampleArray>>rleast:
- Run test case VTTests>>testCArleast5
- Open Trace Viewer and explore.
- Remove Probes.
- Erase events.

execute
	| method |
	method := self compiledMethod.
	(JInstrumentedMethods includesKey: (Array with: method methodClass with: method selector))
		ifTrue: [ 
			method methodClass
				addSelector: method selector
				withMethod: (JInstrumentedMethods at: (Array with: method methodClass with: method selector)) ]
		ifFalse: [ JVariableProbesWriter analyse: method selector in: method methodClass ].
'! !

!JHelp class methodsFor: 'pages' stamp: 'ThierryGoubier 7/18/2012 11:14'!
thirdPage
	^ HelpTopic
		title: 'The Jejak Trace framework - Framework'
		contents: 'Framework Guide

1- Elements of the framework

- JProbesWriter : writes probes in the AST of a method before recompilation.
- JAbstractRecord : record classes for recording events.
- JRecordVisiteur : classes for visiting a recorded event trace and changing it.
- JViewer : the GUI.
- JCollecteur : the singleton to link to a recording events object.
- JRecorded : an object recording events.
- JInstrumentedMethods : where all methods with probes are kept.
- JCmdTrace : OmniBrowser integration.

2- JProbesWriter

The core of the system. Requires a smalltalk parser and compiler to generate the AST for the method, as well as
compiling a transformed AST.'! !

RBProgramNodeVisitor subclass: #JCodeNodeFinder
	instanceVariableNames: 'target no'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JCodeNodeFinder commentStamp: '<historical>' prior: 0!
CodeNodeFinder search through a parse tree to find a given node with a target number (numbering scheme based on a depth-first traversal of the parse tree). Follows the numbering scheme implemented in CodeAnalyserWriter. Returns the node found and the path to it.

Instance Variables:
	no	<SmallInteger>	the current node number
	stack	<OrderedCollection of ProgramNode>	The path in the trace tree: last element is the current node
	target	<SmallInteger>	the target node number
!

!JCodeNodeFinder class methodsFor: 'accessing' stamp: 'ThierryGoubier 7/18/2012 10:06'!
find: aNodeId in: aMethod
	"Find a node in an ast in parameter."

	| c |
	c := self new.
	c target: aNodeId.
	[ c visitNode: (RBParser parseMethod: aMethod getSource) ]
		on: JCodeNodeFound
		do: [ :ex | ^ ex tag ].
	^ SubscriptOutOfBounds signal! !

!JCodeNodeFinder methodsFor: 'initialize-release' stamp: 'ThierryGoubier 6/22/2012 15:39'!
initialize
	no := 1! !

!JCodeNodeFinder methodsFor: 'accessing' stamp: 'ThierryGoubier 6/22/2012 23:44'!
target: aNodeId
	"Initialize the target and the no."

	target := aNodeId.
	no := 1! !

!JCodeNodeFinder methodsFor: 'visiting' stamp: 'ThierryGoubier 7/18/2012 10:06'!
visitArgument: aNode
	"Check if we have the right node. If yes, return it. If not, continue the search."

	^ target == no
		ifTrue: [ 
			JCodeNodeFound new
				tag: aNode;
				signal ]
		ifFalse: [ 
			no := no + 1.
			aNode acceptVisitor: self ]! !

!JCodeNodeFinder methodsFor: 'visiting' stamp: 'ThierryGoubier 7/18/2012 10:06'!
visitNode: aNode
	"Check if we have the right node. If yes, return it. If not, continue the search."

	^ target == no
		ifTrue: [ 
			JCodeNodeFound new
				tag: aNode;
				signal ]
		ifFalse: [ 
			no := no + 1.
			aNode acceptVisitor: self ]! !

RBProgramNodeVisitor subclass: #JProbesWriter
	instanceVariableNames: 'mclass no'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JProbesWriter commentStamp: '<historical>' prior: 0!
This class is a root for subclasses that will modify a method by writing tracing code and probes. Basically, it takes a method parse tree (MethodNode) and return a new parse tree.

mclass: contains the class of the method we are processing.
no: the current node counter.

How to use no? Record in a temporary the no at the beginning of the processing of the node; this will uniquely identify the node.
!

JProbesWriter subclass: #JCFGProbesWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JCFGProbesWriter commentStamp: '<historical>' prior: 0!
CodeVariableTracerWriter write probes to track all message sends and code structure (block evaluations in loops)

!

!JCFGProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 7/18/2012 10:06'!
acceptBlockNode: aNode
	"Arguments are the block arguments, instances of RBVariableNode."

	| body args stats last nodeId |
	nodeId := no.
	args := self visitArguments: aNode arguments.
	body := self visitNode: aNode body.
	stats := body statements asOrderedCollection.
	stats
		addFirst:
			(RBMessageNode
				receiver: (RBLiteralValueNode value: #JCollecteur)
				selector: #enter:
				arguments: (Array with: (RBLiteralValueNode value: nodeId))).
	(stats last isKindOf: RBReturnNode)
		ifFalse: [ 
			last := stats removeLast.
			stats
				add:
					(RBMessageNode receiver: (RBLiteralValueNode value: #JCollecteur) selector: #exit: arguments: (Array with: last)) ].
	body statements: stats.
	aNode
		arguments: args;
		body: body.
	^ aNode! !

!JCFGProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 7/18/2012 10:35'!
acceptMessageNode: aNode
	"trace message sends to the collecteur."

	| node rcvr2 args2 nodeId encoder |
	nodeId := no.
	(aNode isCascaded not or: [aNode isFirstCascaded]) 
		ifTrue: [rcvr2 := self visitNode: aNode receiver].
	args2 := self visitArguments: aNode arguments.
	aNode receiver: rcvr2.
	aNode arguments: args2.
	^ RBMessageNode
		receiver: (RBLiteralValueNode value: #JCollecteur)
		selector: #record:node:value:
		arguments:
			(Array with: (RBLiteralValueNode value: aNode selector) with: (RBLiteralValueNode value: nodeId) with: aNode)! !

!JCFGProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 7/18/2012 10:36'!
acceptMethodNode: aNode
	"Add a probe to trace the entry into the method and the included block. Add a ^self at the end of the code and a probe in it if there isn't any yet (disregard cases of code returning allways before that point; we expect smalltalk to optimise that away)."

	| body stats nodeID args2 |
	nodeID := no.
	args2 := self visitArguments: aNode arguments.
	aNode pragmas: (aNode pragmas collect: [ :each | self visitNode: each ]).
	body := self visitNode: aNode body.
	stats := body statements.
	stats
		addFirst:
			(RBMessageNode
				receiver: (RBLiteralValueNode value: #JCollecteur)
				selector: #enter:selector:node:
				arguments:
					(Array
						with: (RBVariableNode named: 'self')
						with: (RBLiteralValueNode value: aNode selector)
						with: (RBLiteralValueNode value: nodeID))).
	(stats last isKindOf: RBReturnNode)
		ifFalse: [ 
			stats
				add:
					(RBReturnNode
						value:
							(RBMessageNode
								receiver: (RBLiteralValueNode value: #JCollecteur)
								selector: #return:
								arguments: (Array with: (VariableNode new name: 'self')))) ].
	aNode arguments: args2.
	body statements: stats.
	aNode body: body.
	^ aNode! !

!JCFGProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 7/18/2012 10:06'!
acceptReturnNode: aNode
	^ aNode
		value:
			(RBMessageNode
				receiver: (RBLiteralValueNode value: #JCollecteur)
				selector: #return:
				arguments: (Array with: (self visitNode: aNode value)))! !

JCFGProbesWriter subclass: #JCFGProbesWriterToVar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JCFGProbesWriterToVar commentStamp: 'ThierryGoubier 6/26/2012 10:31' prior: 0!
CodeTracerWriterVar is a variant of CodeTracerWriter which uses a variable instead of a literal to target the collecteur, to see if we can reduce the tracking overhead. It's apparently not the case, so it will probably go unused.!

!JCFGProbesWriterToVar methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/25/2012 23:26'!
acceptBlockNode: aNode
	"Arguments are the block arguments, instances of RBVariableNode."

	| body args stats last nodeId |
	nodeId := no.
	args := self visitArguments: aNode arguments.
	body := self visitNode: aNode body.
	stats := body statements asOrderedCollection.
	stats
		addFirst:
			(RBMessageNode
				receiver: self collecteurVariable
				selector: #enter:
				arguments: (Array with: (RBLiteralValueNode value: nodeId))).
	(stats last isKindOf: RBReturnNode)
		ifFalse: [ 
			last := stats removeLast.
			stats add: (RBMessageNode receiver: self collecteurVariable selector: #exit: arguments: (Array with: last)) ].
	body statements: stats.
	aNode
		arguments: args;
		body: body.
	^ aNode! !

!JCFGProbesWriterToVar methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/25/2012 23:26'!
acceptMessageNode: aNode
	"trace message sends to the collecteur."

	| node rcvr2 args2 nodeId encoder |
	nodeId := no.
	rcvr2 := self visitNode: aNode receiver.
	args2 := self visitArguments: aNode arguments.
	aNode receiver: rcvr2.
	aNode arguments: args2.
	^ RBMessageNode
		receiver: self collecteurVariable
		selector: #record:node:value:
		arguments:
			(Array with: (RBLiteralValueNode value: aNode selector) with: (RBLiteralValueNode value: nodeId) with: aNode)! !

!JCFGProbesWriterToVar methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/25/2012 23:27'!
acceptMethodNode: aNode
	"Add a probe to trace the entry into the method and the included block. Add a ^self at the end of the code and a probe in it if there isn't any yet (disregard cases of code returning allways before that point; we expect smalltalk to optimise that away)."

	| body stats nodeID args2 |
	nodeID := no.
	args2 := self visitArguments: aNode arguments.
	body := self visitNode: aNode body.
	stats := body statements.
	stats
		addFirst:
			(RBMessageNode
				receiver: self collecteurVariable
				selector: #enter:selector:node:
				arguments:
					(Array
						with: (RBVariableNode named: 'self')
						with: (RBLiteralValueNode value: aNode selector)
						with: (RBLiteralValueNode value: nodeID))).
	(stats last isKindOf: RBReturnNode)
		ifFalse: [ 
			stats
				add:
					(RBReturnNode
						value:
							(RBMessageNode
								receiver: self collecteurVariable
								selector: #return:
								arguments: (Array with: (VariableNode new name: 'self')))) ].
	aNode arguments: args2.
	body statements: stats.
	aNode body: body.
	^ aNode! !

!JCFGProbesWriterToVar methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/25/2012 23:28'!
acceptReturnNode: aNode
	^ aNode
		value:
			(RBMessageNode
				receiver: self collecteurVariable
				selector: #return:
				arguments: (Array with: (self visitNode: aNode value)))! !

!JCFGProbesWriterToVar methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/25/2012 23:29'!
changeLiteralRecorder: aSymbolOrObject to: anObject in: aCompiledMethod
	^ self "Just do nothing"! !

!JProbesWriter class methodsFor: 'code manipulation' stamp: ''!
analyse: aMethodSelector in: aClass 

	^self new analyse: aMethodSelector in: aClass! !

!JProbesWriter class methodsFor: 'code manipulation' stamp: 'ThierryGoubier 7/18/2012 10:07'!
uninstall
	"Go through the originals and reinstate them."

	JInstrumentedMethods 
		keysAndValuesDo: [:key :value | key first addSelector: key last withMethod: value].
	JInstrumentedMethods reset! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/24/2012 08:18'!
acceptArrayNode: anArrayNode
	^ anArrayNode children: (anArrayNode children collect: [ :each | self visitNode: each ])! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/24/2012 08:17'!
acceptAssignmentNode: aNode
	| var2 val2 |
	var2 := self visitNode: aNode variable.
	val2 := self visitNode: aNode value.
	val2 == aNode value
		ifFalse: [ aNode variable: var2 ].
	var2 == aNode
		ifFalse: [ aNode value: val2 ].
	^ aNode! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/21/2012 22:19'!
acceptBlockNode: aNode
	| args body |
	args := self visitArguments: aNode arguments.
	body := self visitNode: aNode body.
	args == aNode arguments
		ifFalse: [ aNode arguments: args ].
	body == aNode body
		ifFalse: [ aNode statements: body ].
	^ aNode! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/21/2012 21:23'!
acceptCascadeNode: aCascadeNode
	aCascadeNode messages: (aCascadeNode messages collect: [ :message | self visitNode: message ]).
	^ aCascadeNode! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/21/2012 21:26'!
acceptLiteralArrayNode: aRBLiteralArrayNode
	^ aRBLiteralArrayNode contents collect: [ :each | self visitNode: each ]! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/21/2012 21:26'!
acceptLiteralNode: aLiteralNode
	^ aLiteralNode! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/21/2012 21:29'!
acceptMessageNode: aMessageNode
	(aMessageNode isCascaded not or: [ aMessageNode isFirstCascaded ])
		ifTrue: [ 
			| rcv |
			rcv := self visitNode: aMessageNode receiver.
			rcv == aMessageNode receiver
				ifFalse: [ aMessageNode receiver: rcv ] ].
	aMessageNode arguments: (aMessageNode arguments collect: [ :each | self visitNode: each ]).
	^ aMessageNode! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/21/2012 22:06'!
acceptMethodNode: aMethodNode
	aMethodNode arguments: (self visitArguments: aMethodNode arguments).
	aMethodNode pragmas: (aMethodNode pragmas collect: [ :each | self visitNode: each ]).
	aMethodNode body: (self visitNode: aMethodNode body).
	^ aMethodNode! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/21/2012 22:09'!
acceptPatternBlockNode: aRBPatternBlockNode
	aRBPatternBlockNode arguments: (self visitArguments: aRBPatternBlockNode arguments).
	aRBPatternBlockNode body: (self visitNode: aRBPatternBlockNode body).
	^ aRBPatternBlockNode! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/21/2012 22:13'!
acceptPatternWrapperBlockNode: aRBPatternWrapperBlockNode
	aRBPatternWrapperBlockNode wrappedNode: (self visitNode: aRBPatternWrapperBlockNode wrappedNode).
	aRBPatternWrapperBlockNode arguments: (self visitArguments: aRBPatternWrapperBlockNode arguments).
	aRBPatternWrapperBlockNode body: (self visitNode: aRBPatternWrapperBlockNode body).
	^ aRBPatternWrapperBlockNode! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/21/2012 22:14'!
acceptPragmaNode: aPragmaNode
	aPragmaNode arguments: (aPragmaNode arguments collect: [ :each | self visitNode: each ]).
	^ aPragmaNode! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/21/2012 22:15'!
acceptReturnNode: aReturnNode
	| v |
	v := self visitNode: aReturnNode value.
	aReturnNode value == v
		ifFalse: [ aReturnNode value: v ].
	^ aReturnNode! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/21/2012 22:17'!
acceptSequenceNode: aSequenceNode
	aSequenceNode temporaries: (self visitArguments: aSequenceNode temporaries).
	aSequenceNode statements: (aSequenceNode statements collect: [ :each | self visitNode: each ]).
	^ aSequenceNode! !

!JProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/21/2012 22:17'!
acceptVariableNode: aVariableNode
	^ aVariableNode! !

!JProbesWriter methodsFor: 'code manipulation' stamp: 'ThierryGoubier 10/7/2012 08:16'!
analyse: aMethodSelector in: aClass
	"Instrument a method, store the original. Has provisions for looking in the
	class hierarchy, but, for now, the uninstall will copy the method in the subclass."

	"Currently, this does not keep the original source. I'd like to keep it, how should this be done? I'll ask."

	| n cm class method array s |
	method := aClass lookupSelector: aMethodSelector.
	class := method methodClass.
	class isNil
		ifTrue: [ ^ self ].
	(JInstrumentedMethods includesKey: (Array with: class with: aMethodSelector))
		ifTrue: [ 
			ExampleBuilderMorph new alert: 'Method already instrumented.'.
			^ self ].
	mclass := class.
	s := method getSource.
	n := RBParser parseMethod: s.
	n := self visitNode: n.
	cm := class
		lookupSelector: (class compile: n formattedCode classified: method category notifying: nil).
	self changeLiteralRecorder: #JCollecteur to: JCollecteur recorder in: cm.
	JInstrumentedMethods at: (Array with: class with: aMethodSelector) put: method! !

!JProbesWriter methodsFor: 'code manipulation' stamp: 'ThierryGoubier 6/25/2012 23:29'!
changeLiteralRecorder: aSymbolOrObject to: anObject in: aCompiledMethod
	"Change the relevant literal to another object in the method."

	"TODO: ask if this should really be done in Pharo, and how it should be done."

	"Self Answer: it has to be done. The literal is in the method, just need to find and replace it."

	aCompiledMethod literalAt: (aCompiledMethod indexOfLiteral: aSymbolOrObject) put: anObject! !

!JProbesWriter methodsFor: 'private' stamp: 'ThierryGoubier 7/18/2012 10:06'!
collecteurLiteral
	^ RBLiteralValueNode value: #JCollecteur! !

!JProbesWriter methodsFor: 'private' stamp: 'ThierryGoubier 6/25/2012 23:39'!
collecteurVariable
	^ (RBVariableNode named: 'Collecteur') binding: (OCGlobalScope new lookupVar: 'Collecteur')! !

!JProbesWriter methodsFor: 'initialize-release' stamp: 'ThierryGoubier 6/21/2012 17:03'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	no := 0! !

!JProbesWriter methodsFor: 'code manipulation' stamp: 'ThierryGoubier 7/18/2012 10:07'!
uninstall
	"Go through the originals and reinstate them."

	JInstrumentedMethods 
		keysAndValuesDo: [:key :value | key first addSelector: key last withMethod: value].
	JInstrumentedMethods reset! !

!JProbesWriter methodsFor: 'visiting-private' stamp: 'ThierryGoubier 6/21/2012 22:07'!
visitArgument: each 
	"Here to allow subclasses to detect arguments or temporaries."

	^self visitNode: each! !

!JProbesWriter methodsFor: 'visiting-private' stamp: 'ThierryGoubier 6/21/2012 22:07'!
visitArguments: aNodeCollection
	^ aNodeCollection collect: [ :each | self visitArgument: each ]! !

!JProbesWriter methodsFor: 'visiting-private' stamp: 'ThierryGoubier 6/21/2012 22:07'!
visitNode: aNode
	"When we do a node, we increase the counter so that we may identify it."

	no := no + 1.
	^ aNode acceptVisitor: self! !

JProbesWriter subclass: #JThreadedProbesWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JThreadedProbesWriter commentStamp: 'ThierryGoubier 7/18/2012 11:26' prior: 0!
ThreadedCodeTracerWriter is tracing code with processes. It's a work in progress, not yet completely ported.!

!JThreadedProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/26/2012 15:33'!
acceptMessage: aNode
	"trace the message send."

	| node rcvr2 args2 nodeId |
	nodeId := no.
	rcvr2 := self visitNode: aNode receiver.
	args2 := self visitArguments: aNode arguments.
	node := RBMessageNode receiver: rcvr2 selector: aNode selector arguments: args2.
	^ RBMessageNode new
		receiver: (RBBlockNode body: (RBSequenceNode statements: (Array with: node)))
		selector: #ensure:
		arguments:
			{(RBBlockNode
				body:
					(RBSequenceNode
						statements:
							{(RBMessageNode
								receiver: (RBVariableNode named: 'ThreadedCollecteur')
								selector: #record:node:
								arguments:
									{(RBLiteralValueNode value: aNode selector).
									(RBLiteralValueNode value: nodeId)})}))}! !

!JThreadedProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/26/2012 15:35'!
acceptMethod: aNode
	| block2 nodeId |
	nodeId := no.
	block2 := self visitNode: aNode body.
	block2 statements
		addFirst:
			(RBMessageNode
				receiver: (RBVariableNode named: 'ThreadedCollecteur')
				selector: #enter:selector:node:
				arguments:
					(Array
						with: (RBVariableNode named: mclass name)
						with: (RBLiteralValueNode value: aNode selector)
						with: (RBLiteralValueNode value: nodeId))).
	^ aNode body: block2! !

!JThreadedProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 6/26/2012 15:37'!
acceptReturn: aNode
	| ensureNode receiverNode |
	ensureNode := RBBlockNode
		body:
			(RBSequenceNode new
				statements:
					(Array
						with:
							(RBMessageNode new receiver: (RBVariableNode named: 'ThreadedCollecteur') selector: #exitLevel arguments: #()))).
	receiverNode := RBBlockNode body: (RBSequenceNode statements: (Array with: (self visitNode: aNode value))).
	^ aNode value: (RBMessageNode receiver: receiverNode selector: #ensure: arguments: (Array with: ensureNode))! !

JProbesWriter subclass: #JVariableProbesWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JVariableProbesWriter commentStamp: '<historical>' prior: 0!
CodeVariableTracerWriter write probes to track variable definition, assignments (and values), parameters and arguments, as well as all message sends and code structure (block evaluations in loops)

!

!JVariableProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 7/18/2012 10:39'!
acceptAssignmentNode: aNode
	"Replace the assignment by a message node holding the assignment as one of the arguments."

	| var2 val2 nodeId |
	nodeId := no.
	var2 := self visitNode: aNode variable.
	val2 := self visitNode: aNode value.
	^RBMessageNode 
		receiver: (RBLiteralValueNode value: #JCollecteur)
		selector: #assign:to:node:
		arguments: (Array 
				with: (aNode variable: var2; value: val2)
				with: (RBLiteralValueNode value: var2 name)
				with: (RBLiteralValueNode value: nodeId))! !

!JVariableProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 10/7/2012 08:20'!
acceptBlockNode: aNode 
	"Don't know what args are, but I'll suppose they are variables. Or do I need to track variables that are read? Everywhere in the code?"

	| body args stats last nodeId |
	nodeId := no.
	args := self visitArguments: aNode arguments.
	body := self visitNode: aNode body.
	stats := body statements asOrderedCollection.
	args isEmpty 
		ifFalse: 
			[args reverseDo: 
					[:a | 
					stats addFirst: (RBMessageNode  
								receiver: (RBLiteralValueNode value: #JCollecteur)
								selector: #assign:to:node:
								arguments: (Array 
										with: a
										with: (RBLiteralValueNode value: a name)
										with: (RBLiteralValueNode value: nodeId)))]].
	stats addFirst: (RBMessageNode 
				receiver: (RBLiteralValueNode value: #JCollecteur)
				selector: #enter:
				arguments: (Array with: (RBLiteralValueNode value: nodeId))).
	last := stats last.
	(last isKindOf: RBReturnNode)
		ifFalse: 
			[stats removeLast.
			stats add: (RBMessageNode 
						receiver: (RBLiteralValueNode value: #JCollecteur)
						selector: #exit:
						arguments: (Array with: last))].
	body statements: stats.
	aNode
		arguments: args;
		body: body.
	^ aNode! !

!JVariableProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 7/18/2012 10:06'!
acceptMessageNode: aNode
	"Detect at: put: and record it via a new, specific collector message. Note that, to simplify the code, the effective at:put: is sent in the Collecteur instance and not in the original code."

	| receiver arguments nodeId |
	nodeId := no.
	receiver := self visitNode: aNode receiver.
	arguments := self visitArguments: aNode arguments.
	^ (aNode selector == #at:put: and: [ receiver isKindOf: RBVariableNode ])
		ifTrue: [ 
			RBMessageNode
				receiver: (RBLiteralValueNode value: #JCollecteur)
				selector: #assign:to:named:at:node:
				arguments:
					{(arguments last).
					receiver.
					(RBLiteralValueNode value: receiver name).
					(arguments first).
					(RBLiteralValueNode value: nodeId)} ]
		ifFalse: [ 
			RBMessageNode
				receiver: (RBLiteralValueNode value: #JCollecteur)
				selector: #record:node:value:
				arguments:
					{(RBLiteralValueNode value: aNode selector).
					(RBLiteralValueNode value: nodeId).
					(aNode
						receiver: receiver;
						arguments: arguments)} ]! !

!JVariableProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 7/18/2012 10:06'!
acceptMethodNode: aNode
	"Add a probe to trace the entry into the method and the included block. Add a ^self at the end of the code and a probe in it if there isn't any yet (disregard cases of code returning allways before that point; we expect smalltalk to optimise that away)."

	| body stats nodeId args2 |
	nodeId := no.
	args2 := self visitArguments: aNode arguments.
	body := self visitNode: aNode body.
	stats := body statements.
	args2 isEmpty
		ifFalse: [ 
			args2
				reverseDo: [ :a | 
					stats
						addFirst:
							(RBMessageNode
								receiver: (RBLiteralValueNode value: #JCollecteur)
								selector: #assign:to:node:
								arguments:
									{a.
									(RBLiteralValueNode value: a name).
									(RBLiteralValueNode value: nodeId)}) ] ].
	stats
		addFirst:
			(RBMessageNode
				receiver: (RBLiteralValueNode value: #JCollecteur)
				selector: #enter:selector:node:
				arguments:
					(Array
						with: (RBVariableNode named: 'self')
						with: (RBLiteralValueNode value: aNode selector)
						with: (RBLiteralValueNode value: nodeId))).
	(stats last isKindOf: RBReturnNode)
		ifFalse: [ 
			stats
				add:
					(RBReturnNode
						value:
							(RBMessageNode
								receiver: (RBLiteralValueNode value: #JCollecteur)
								selector: #return:
								arguments: (Array with: (RBVariableNode named: 'self')))) ].
	aNode arguments: args2.
	body statements: stats.
	aNode body: body.
	^ aNode! !

!JVariableProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 7/18/2012 10:06'!
acceptReturnNode: aNode
	| receiverNode nodeId |
	nodeId := no.
	^ aNode
		value:
			(RBMessageNode
				receiver: (RBLiteralValueNode value: #JCollecteur)
				selector: #return:node:
				arguments: (Array with: (self visitNode: aNode value) with: (RBLiteralValueNode value: nodeId)))! !

!JVariableProbesWriter methodsFor: 'visitor-double dispatching' stamp: 'ThierryGoubier 7/18/2012 10:06'!
acceptSequenceNode: aNode
	| tps2 body nodeId stats |
	nodeId := no.
	tps2 := aNode temporaries collect: [ :e | self visitNode: e].
	stats := aNode statements collect: [ :s | self visitNode: s].
	tps2 isEmpty
		ifFalse: [ 
			stats
				addFirst:
					(RBMessageNode
						receiver: (RBLiteralValueNode value: #JCollecteur)
						selector: #define:node:
						arguments:
							{(RBLiteralValueNode value: (tps2 collect: [ :a | a name ]) asArray printString).
							(RBLiteralValueNode value: nodeId)}) ].
	aNode statements: stats.
	aNode temporaries: tps2.
	^ aNode! !

Array variableSubclass: #JExampleArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JExampleArray commentStamp: '<historical>' prior: 0!
CAExampleArray contains two methods for the search of the k smallest elements in the array and return their values and their positions. It is an example for testing of the code analysis tools.

The origin is in the search for the least reliable symbols in a SISO decoder for block turbo decoding [1].

[1] R. Pyndiah, A.Glavieux, A. Picart, and S.Jacq. "Near optimum decoding of product codes", In IEEE GLOBECOM'1994 Conference, December 1994
!

!JExampleArray methodsFor: 'actions' stamp: ''!
least: anArray1 array2: anArray2 
	"Sort the two arrays into one. May have one array smaller than the other. Arrays are sorted, so the algorithm is simplified."

	| sz v p i j k a1 a2 p1 p2 |
	a1 := anArray1 first.
	p1 := anArray1 last.
	a2 := anArray2 first.
	p2 := anArray2 last.
	sz := a1 size max: a2 size.
	v := Array new: sz.
	p := Array new: sz.
	i := 1.
	j := 1.
	k := 1.
	[k <= sz] whileTrue: 
			[(i > a1 size or: [j <= a2 size and: [(a2 at: j) < (a1 at: i)]]) 
				ifTrue: 
					[v at: k put: (a2 at: j).
					p at: k put: (p2 at: j).
					j := j + 1.
					k := k + 1]
				ifFalse: 
					[v at: k put: (a1 at: i).
					p at: k put: (p1 at: i).
					k := k + 1.
					i := i + 1]].
	^Array with: v with: p! !

!JExampleArray methodsFor: 'actions' stamp: ''!
reorder: anArray 
	"Reorder all elements of this array in a new Array, recording the positions. This is a building block to be able to then do the sort of the five smallest values."

	| sz p v |
	sz := anArray size.
	v := Array new: sz.
	p := Array new: sz.
	v at: 1 put: (anArray at: 1).
	p at: 1 put: 1.
	2 to: sz
		do: 
			[:i | 
			| valeur j |
			valeur := anArray at: i.
			j := 1.
			[j < i] whileTrue: 
					[valeur < (v at: j) 
						ifTrue: 
							[i to: j + 1
								by: -1
								do: 
									[:k | 
									v at: k put: (v at: k - 1).
									p at: k put: (p at: k - 1)].
							v at: j put: valeur.
							p at: j put: i.
							j := sz + 1]
						ifFalse: [j := j + 1]].
			j = i 
				ifTrue: 
					[v at: i put: valeur.
					p at: i put: i]].
	^Array with: v with: p! !

!JExampleArray methodsFor: 'actions' stamp: 'ThierryGoubier 6/26/2012 17:15'!
rleast: k 
	"Recursive least k elements on anArray. If the array is k in length or less, return it ordered. Else, divide."

	| n a1 a2 ml |
	n := ((self size + k - 1) / k) truncated.
	n == 1 ifTrue: [^self reorder: self].
	ml := (n / 2) truncated * k.
	a1 := (self copyFrom: 1 to: ml) rleast: k.
	a2 := (self copyFrom: ml + 1 to: self size) rleast: k.
	a2 at: 2 put: (a2 last collect: [:p | p + ml]).
	^self least: a1 array2: a2! !

MorphTreeModel subclass: #JViewer
	instanceVariableNames: 'records source tree textMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JViewer commentStamp: '<historical>' prior: 0!
TraceViewer display a trace in a tree+source UI.

Instance Variables:
	records	<SelectionInList>	 The records displayed
	source	<ValueModel on: Text>	The source code related to the current (selected) record
	tree	<TreeModel>	The tree based on the trace

!

!JViewer class methodsFor: 'user interface' stamp: 'ThierryGoubier 6/26/2012 15:52'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'Trace Viewer')
			parent: #Tools;
			action: [ self open ]; 
			help: 'View / Explore / Reset traces'.! !

!JViewer class methodsFor: 'user interface' stamp: 'ThierryGoubier 6/25/2012 16:36'!
open
	^self new open! !

!JViewer methodsFor: 'actions' stamp: 'ThierryGoubier 6/24/2012 22:23'!
apply: aRV
	self selection isNil
		ifFalse: [ 
			(aRV do: self selection)
				ifTrue: [ self update ] ]! !

!JViewer methodsFor: 'aspects' stamp: 'ThierryGoubier 6/22/2012 16:29'!
defaultTreeMorph
	^ super defaultTreeMorph
		doubleClickSelector: #doubleClick;
		nodeStringGetter: #asString;
		getMenuSelector: #menu:shifted:! !

!JViewer methodsFor: 'actions' stamp: 'ThierryGoubier 6/22/2012 16:49'!
doubleClick
	self selectedNode ifNotNil: [:n | n doubleClick]! !

!JViewer methodsFor: 'actions' stamp: 'ThierryGoubier 6/22/2012 16:48'!
keyStroke: anEvent from: aTreeMorph 
	self selectedNode
		ifNotNil: [:current | current keyStroke: anEvent from: aTreeMorph]! !

!JViewer methodsFor: 'actions' stamp: 'ThierryGoubier 6/22/2012 16:48'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, 
	honoring the #shifted boolean"
	self selectedNode ifNotNil: [:current | current menu: menu shifted: b].
	^ menu! !

!JViewer methodsFor: 'ui' stamp: 'ThierryGoubier 6/22/2012 20:35'!
open
	"Will have to change that."

	(self windowIn: World title: 'Trace Recorder') open! !

!JViewer methodsFor: 'aspects' stamp: 'ThierryGoubier 7/18/2012 10:08'!
recordVisitorMenu: aMenu
	"A menu which should depend on existing record visitors."

	JRecordVisiteur allSubclasses
		do: [ :e | 
			aMenu
				add: e menuLabel
				target: self
				selector: #apply:
				argumentList: {(e new)} ].
	aMenu addLine.
	aMenu add: 'inspect' target: self selector: #inspectRecord.
	^ aMenu! !

!JViewer methodsFor: 'actions' stamp: 'ThierryGoubier 7/18/2012 10:06'!
resetRecorder
	JCollecteur recorder reset.
	self changed: #rootNodes.
	source contents: ''! !

!JViewer methodsFor: 'aspects' stamp: 'ThierryGoubier 7/18/2012 10:06'!
rootItems
	^ JCollecteur recorder elements! !

!JViewer methodsFor: 'aspects' stamp: 'ThierryGoubier 7/18/2012 10:09'!
rootNodeClassFromItem: anItem
	^ JViewerNode! !

!JViewer methodsFor: 'actions' stamp: 'ThierryGoubier 7/18/2012 10:07'!
selection: anItem
	"We have a selected record item. We need to show the source and select it."

	| r s a i path node m n |
	anItem selectedNodePath isNil ifTrue: [^self].
	super selection: anItem.
	r := anItem.
	path := anItem lastSelectedNodePath.
	node := anItem lastSelectedNode item.
	i := path size.
	r := path last item.
	[ i <= 0 or: [ r isMethod ] ]
		whileFalse: [ 
			i := i - 1.
			r := (path at: i) item ].
	i = 0
		ifTrue: [ ^ self ].
	a := r mclass lookupSelector: r selector.
	a isNil
		ifTrue: [ ^ self ].
	m := JInstrumentedMethods at: (Array with: a methodClass with: r selector) ifAbsent: [ a ].
	s := m getSource.
	n := JCodeNodeFinder find: node nodeId in: m.
	s isNil
		ifTrue: [ ^ self ].
	source contents: s.
	textMorph deselect.
	textMorph selectFrom: n sourceInterval first to: n sourceInterval last! !

!JViewer methodsFor: 'initialize-release' stamp: 'ThierryGoubier 5/22/2012 11:28'!
setRoot: aRoot
	"Reset the root to something else than the default recorder."

	tree roots: aRoot childrenNodes! !

!JViewer methodsFor: 'aspects' stamp: 'ThierryGoubier 6/22/2012 23:56'!
source
	^ source isNil
		ifTrue: [ source := String new asValueHolder ]
		ifFalse: [ source ]! !

!JViewer methodsFor: 'actions' stamp: 'ThierryGoubier 7/18/2012 10:07'!
uninstall
	"Uninstall traces"

	JProbesWriter uninstall! !

!JViewer methodsFor: 'actions' stamp: 'ThierryGoubier 6/24/2012 22:38'!
update
	self changed: #rootNodes! !

!JViewer methodsFor: 'ui' stamp: 'ThierryGoubier 6/24/2012 22:37'!
windowIn: aWindow title: aTitle
	| window treeMorph toolbar dock |
	window := self theme newWindowIn: aWindow for: self title: aTitle.
	toolbar := window
		newToolbar:
			{(window
				newButtonFor: self
				action: #resetRecorder
				label: 'Erase events'
				help: 'Erase all recorded events').
			(window
				newButtonFor: self
				action: #uninstall
				label: 'Remove probes'
				help: 'Erase all probes, restore original code').
			(window
				newButtonFor: self
				action: #update
				label: 'Update'
				help: 'Update the list of events')}.
	treeMorph := self defaultTreeMorph.
	treeMorph buildContents.
	dock := window newToolDockingBar.
	dock addMorphBack: toolbar.
	window
		addMorph: dock
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ dock minExtent y)).
	window
		addMorph: treeMorph
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 0.3 @ 1) offsets: (0 @ dock minExtent y corner: 0 @ 0)).
	textMorph := PluggableTextMorph on: self source text: #contents accept: nil.
	window
		addMorph: textMorph
		fullFrame: (LayoutFrame fractions: (0.3 @ 0 corner: 1 @ 1) offsets: (0 @ dock minExtent y corner: 0 @ 0)).
	window minimumExtent: 500 @ 500.
	^ window! !

MorphTreeNodeModel subclass: #JViewerNode
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JViewerNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 6/22/2012 16:45'!
asString
	^ self item printString! !

!JViewerNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/18/2012 10:09'!
childNodeClassFromItem: anItem
	^ JViewerNode! !

!JViewerNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 6/22/2012 16:45'!
childrenItems
	^ self item children ! !

!JViewerNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 6/24/2012 22:16'!
doubleClick
	self exploreItem! !

!JViewerNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 6/22/2012 16:47'!
exploreItem
	self explore! !

!JViewerNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 6/22/2012 16:47'!
inspectItem
	self inspect! !

!JViewerNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 6/24/2012 22:17'!
keyStroke: anEvent from: aTreeMorph
	| c |
	c := anEvent keyCharacter.
	c = $i
		ifTrue: [self inspectItem. ^ true].
	c = $I
		ifTrue: [self exploreItem. ^ true].
	^ false
! !

!JViewerNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 6/24/2012 22:16'!
menu: menu shifted: b
	menu add: 'Expand all' translated target: self selector: #expandAll.
	menu add: 'Inspect (i)' translated target: self selector: #inspectItem.
	menu add: 'Explore (I)' translated target: self selector: #exploreItem! !

Object subclass: #JAbstractRecord
	instanceVariableNames: 'children nodeId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JAbstractRecord commentStamp: '<historical>' prior: 0!
AbstractRecord is the abstract class definign records for trace tree building. It represent a node of the tree

Instance Variables:
	children	<OrderedCollection>	childrens of the node (if any) otherwise empty
	nodeId	<SmallInteger>	The node number in the trace tree

!

!JAbstractRecord methodsFor: 'accessing' stamp: 'ThierryGoubier 5/21/2012 14:35'!
addChild: aNode
	children isNil ifTrue: [children := LinkedList new].
	children addLast: aNode! !

!JAbstractRecord methodsFor: 'private' stamp: ''!
children
	children isNil ifTrue: [children := LinkedList new].
	^children! !

!JAbstractRecord methodsFor: 'accessing' stamp: ''!
childrenNodes
	^self children asArray collect: [:lv | lv value]! !

!JAbstractRecord methodsFor: 'testing' stamp: ''!
hasChildren
	^children notNil and: [children notEmpty]! !

!JAbstractRecord methodsFor: 'testing' stamp: ''!
isMethod
	^false! !

!JAbstractRecord methodsFor: 'testing' stamp: 'ThierryGoubier 5/21/2012 15:30'!
isRoot
	self subclassResponsibility! !

!JAbstractRecord methodsFor: 'private' stamp: ''!
node: n
	nodeId := n! !

!JAbstractRecord methodsFor: 'accessing' stamp: ''!
nodeId
	^nodeId! !

!JAbstractRecord methodsFor: 'visualisation' stamp: 'ThierryGoubier 7/18/2012 10:09'!
open
	(JViewer new setRoot: self) open! !

!JAbstractRecord methodsFor: 'private' stamp: ''!
setChildren: aCollection
	children := aCollection! !

JAbstractRecord subclass: #JRecordBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JRecordBlock commentStamp: '<historical>' prior: 0!
RecordBlock record a probe on a block (entry in a block)

!

!JRecordBlock methodsFor: 'printing' stamp: ''!
printOn: aStream
	aStream nextPutAll: '[]'! !

!JRecordBlock methodsFor: 'visitor' stamp: ''!
recordDo: aRecordVisiteur
	aRecordVisiteur doBlock: self! !

JAbstractRecord subclass: #JRecordItem
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JRecordItem commentStamp: '<historical>' prior: 0!
RecordItem records a message send (or operator)

Instance Variables:
	selector	<a Symbol>	the selector of the message
!

!JRecordItem methodsFor: 'testing' stamp: ''!
isMethod
	^false! !

!JRecordItem methodsFor: 'testing' stamp: ''!
isRoot
	^selector = #root! !

!JRecordItem methodsFor: 'printing' stamp: ''!
printOn: aStream
	(selector isKindOf: Symbol)
		ifTrue: [selector printOn: aStream]
		ifFalse: [aStream nextPutAll: selector]! !

!JRecordItem methodsFor: 'visitor' stamp: ''!
recordDo: aRecordVisiteur
	^aRecordVisiteur doItem: self! !

!JRecordItem methodsFor: 'accessing' stamp: ''!
selector
	^selector! !

!JRecordItem methodsFor: 'private' stamp: ''!
selector: sel node: n
	selector := sel.
	nodeId := n! !

JRecordItem subclass: #JRecordMethod
	instanceVariableNames: 'object args'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JRecordMethod commentStamp: '<historical>' prior: 0!
RecordMethod records the entry in a method

Instance Variables:
	object	<Object>	contains a dcopy of self when entering the method. It also gives access to the class.

!

!JRecordMethod methodsFor: 'testing' stamp: ''!
isMethod
	^true! !

!JRecordMethod methodsFor: 'accessing' stamp: ''!
mclass
	^object class! !

!JRecordMethod methodsFor: 'accessing' stamp: ''!
object: anObject
	object := anObject! !

!JRecordMethod methodsFor: 'private' stamp: ''!
object: anObject selector: sel node: n
	super selector: sel node: n.
	object := anObject! !

!JRecordMethod methodsFor: 'visitor' stamp: ''!
recordDo: aRecordVisiteur
	^aRecordVisiteur doMethod: self! !

JAbstractRecord subclass: #JRecordVariable
	instanceVariableNames: 'var'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JRecordVariable commentStamp: '<historical>' prior: 0!
RecordVariable contains the definition of one or more variables. Var contains the name of the variable(s)

Instance Variables:
	var	<String>	The name of the variable(s)

!

JRecordVariable subclass: #JRecordAssignment
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JRecordAssignment commentStamp: '<historical>' prior: 0!
RecordAssignment record an assignment to a variable.

Instance Variables:
	value	<Object>	the value assigned to a variable

!

!JRecordAssignment methodsFor: 'printing' stamp: ''!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' <- '.
	value printOn: aStream! !

!JRecordAssignment methodsFor: 'visitor' stamp: ''!
recordDo: aRecordVisitor
	^aRecordVisitor doAssignment: self! !

!JRecordAssignment methodsFor: 'accessing' stamp: ''!
value
	^value! !

!JRecordAssignment methodsFor: 'private' stamp: ''!
var: aVarName node: n value: val 
	super var: aVarName node: n.
	value := val! !

!JRecordVariable methodsFor: 'printing' stamp: ''!
printOn: aStream 
	(var isKindOf: Array) 
		ifTrue: 
			[aStream nextPutAll: '| '.
			var do: 
					[:e | 
					aStream
						nextPutAll: e;
						space].
			aStream nextPut: $|]
		ifFalse: [aStream nextPutAll: var]! !

!JRecordVariable methodsFor: 'visitor' stamp: ''!
recordDo: aRecordVisiteur
	^aRecordVisiteur doVariable: self! !

!JRecordVariable methodsFor: 'private' stamp: ''!
var: aVarName node: n
	var := aVarName.
	nodeId := n! !

Object subclass: #JCollecteur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

JCollecteur class
	instanceVariableNames: 'recorder'!

!JCollecteur commentStamp: '<historical>' prior: 0!
Collecteur is the class doing the interface to an instance of TraceRecorder (or ThreadedTraceRecorder, EmptyRecorder). This instance is contained in a class variable named "recorder"
!

JCollecteur class
	instanceVariableNames: 'recorder'!

!JCollecteur class methodsFor: 'events-registering' stamp: 'ThierryGoubier 6/25/2012 23:31'!
enter: aNid
	^ recorder enter: aNid! !

!JCollecteur class methodsFor: 'events-registering' stamp: 'ThierryGoubier 6/25/2012 23:34'!
enter: rcv selector: sel node: nid
	^ recorder enter: rcv selector: sel node: nid! !

!JCollecteur class methodsFor: 'events-registering' stamp: 'ThierryGoubier 6/25/2012 23:32'!
exit: aNid
	^ recorder exit: aNid! !

!JCollecteur class methodsFor: 'initialize-release' stamp: 'ThierryGoubier 7/18/2012 10:09'!
initialize
	"Collecteur initialize"

	recorder := JRecorder new! !

!JCollecteur class methodsFor: 'events-registering' stamp: 'ThierryGoubier 6/25/2012 23:33'!
record: sel node: nid value: aValue
	^ recorder record: sel node: nid value: aValue! !

!JCollecteur class methodsFor: 'recorder accessing' stamp: ''!
recorder
	^recorder! !

!JCollecteur class methodsFor: 'recorder accessing' stamp: ''!
recorder: anObject
	recorder := anObject! !

!JCollecteur class methodsFor: 'events-registering' stamp: 'ThierryGoubier 6/25/2012 23:35'!
return: aValue
	^ recorder return: aValue! !

Object subclass: #JEmptyRecorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JEmptyRecorder commentStamp: '<historical>' prior: 0!
EmptyRecorder is an empty recorder: it receives events and discard them. Used to measure the overhead of the trace.

!

!JEmptyRecorder methodsFor: 'execution graph' stamp: ''!
assign: aValue to: aVar named: aName at: anIndex node: n
	^aVar at: anIndex put: aValue! !

!JEmptyRecorder methodsFor: 'execution graph' stamp: ''!
assign: aValue to: aVar node: n 
	^aValue! !

!JEmptyRecorder methodsFor: 'execution graph' stamp: ''!
define: vars node: n! !

!JEmptyRecorder methodsFor: 'execution graph' stamp: ''!
enter: nid! !

!JEmptyRecorder methodsFor: 'execution graph' stamp: ''!
enter: mclass selector: sel node: nid! !

!JEmptyRecorder methodsFor: 'execution graph' stamp: ''!
exit: v
	^v! !

!JEmptyRecorder methodsFor: 'execution graph' stamp: ''!
exitLevel! !

!JEmptyRecorder methodsFor: 'execution graph' stamp: ''!
record: aSelector node: n
	^aSelector! !

!JEmptyRecorder methodsFor: 'execution graph' stamp: ''!
record: aSelector node: n value: v
	^v! !

!JEmptyRecorder methodsFor: 'execution graph' stamp: ''!
reset
	"Do nothing"! !

!JEmptyRecorder methodsFor: 'execution graph' stamp: ''!
return: aValue
	^aValue! !

!JEmptyRecorder methodsFor: 'execution graph' stamp: ''!
return: aValue node: n 
	^aValue! !

Object subclass: #JInstrumentedMethods
	instanceVariableNames: ''
	classVariableNames: 'array'
	poolDictionaries: ''
	category: 'Jejak'!

!JInstrumentedMethods commentStamp: 'ThierryGoubier 7/18/2012 11:26' prior: 0!
JInstrumentedMethods is the list of instrumented methods (methods with probes inside).!

!JInstrumentedMethods class methodsFor: 'class variables' stamp: 'ThierryGoubier 6/23/2012 23:06'!
array
	array isNil ifTrue: [array := Dictionary new].
	^ array! !

!JInstrumentedMethods class methodsFor: 'class variables' stamp: 'ThierryGoubier 6/26/2012 17:07'!
at: aKey
	^ self array at: aKey! !

!JInstrumentedMethods class methodsFor: 'class variables' stamp: 'ThierryGoubier 6/22/2012 23:29'!
at: aKey ifAbsent: aBlock
	^ self array at: aKey ifAbsent: aBlock! !

!JInstrumentedMethods class methodsFor: 'class variables' stamp: 'ThierryGoubier 5/22/2012 13:13'!
at: aKey put: aValue
	self array at: aKey put: aValue! !

!JInstrumentedMethods class methodsFor: 'class variables' stamp: 'ThierryGoubier 5/22/2012 13:14'!
includesKey: aKey
	^ self array includesKey: aKey! !

!JInstrumentedMethods class methodsFor: 'class variables' stamp: 'ThierryGoubier 6/22/2012 09:29'!
keysAndValuesDo: aBlock
	^ self array keysAndValuesDo: aBlock! !

!JInstrumentedMethods class methodsFor: 'class variables' stamp: 'ThierryGoubier 6/22/2012 09:30'!
reset
	array := nil! !

Object subclass: #JRecordVisiteur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JRecordVisiteur commentStamp: '<historical>' prior: 0!
RVRecordVisiteur is targeted to visiting a tree of records from a TraceRecorder instance. It is an abstract class implementing the visitor protocol as needed.

!

JRecordVisiteur subclass: #JCountOperator
	instanceVariableNames: 'operators'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JCountOperator commentStamp: '<historical>' prior: 0!
RVCountOperator count operators in a trace tree

Instance Variables:
	operators	<Set>	The set of operators as counted

!

!JCountOperator class methodsFor: 'resources' stamp: ''!
menuLabel
	^'count operators'! !

!JCountOperator class methodsFor: 'instance creation' stamp: ''!
new
	^super new initialize! !

!JCountOperator methodsFor: 'accessing' stamp: ''!
do: anAbstractRecord
	"start the visit on the first record item. Returns true or false to indicate
	changes to the subtree."

	self doRecord: anAbstractRecord.
	operators inspect.
	^false! !

!JCountOperator methodsFor: 'enumerating' stamp: ''!
doItem: aRecord
	"Do an item node."

	operators add: aRecord selector.
	^super doItem: aRecord! !

!JCountOperator methodsFor: 'initialize-release' stamp: ''!
initialize
	operators := Bag new! !

JRecordVisiteur subclass: #JLoopArrange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JLoopArrange commentStamp: '<historical>' prior: 0!
RecordLoopExtractor recognize and extract loops from a trace, making them appear as new nodes and levels.

Approach:
!

!JLoopArrange class methodsFor: 'resources' stamp: ''!
menuLabel
	^'arrange loops'! !

!JLoopArrange methodsFor: 'accessing' stamp: ''!
do: anAbstractRecord
	super do: anAbstractRecord.
	^true! !

!JLoopArrange methodsFor: 'enumerating-private' stamp: 'ThierryGoubier 7/18/2012 10:05'!
doRecords: records 
	"Fuse blocks indications into the loop structure. Should probably be able to track even blocks defined as variables."

	"Algorithme:
		first iterate through the records.
		if the child is a message send (a RecordItem), then
			if the previous record is a block, then it was an iteration of a loop message. So move it as a child of the message (removing it from the records).
			Continue backwards and repeat until we find something else than a block.
	Scope:
		seems to work on any message send which has a block as parameter, so including ifTrue:ifFalse: and whileTrue:

	Example:
		if the record structure is
		+-- []
		+-- []
		+-- #to:do:
		Then the two blocks are iterations of the #to:do: and the result will be rewritten as:
		+-- #to:do:
		     +-- []
		     +-- []."

	| r rc tps |
	rc := super doRecords: records.
	tps := OrderedCollection new.
	rc do: 
			[:lv | 
			"This loop searches for message sends; such a message may be a loop construct."

			r := lv value.
			(r isKindOf: JRecordItem) 
				ifTrue: 
					[tps reverseDo: 
							[:i | 
							rc remove: i.
							r children addFirst: i]].
			(r isKindOf: JRecordBlock) 
				ifTrue: [tps add: lv]
				ifFalse: [tps isEmpty ifFalse: [tps := OrderedCollection new]]].
	^rc! !

JRecordVisiteur subclass: #JMethodArrange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JMethodArrange commentStamp: '<historical>' prior: 0!
RVMethodArrange reorganizes a trace tree around method items

!

!JMethodArrange class methodsFor: 'resources' stamp: ''!
menuLabel
	^'arrange method'! !

!JMethodArrange methodsFor: 'accessing' stamp: ''!
do: aRecordItem
	super do: aRecordItem.
	^true! !

!JMethodArrange methodsFor: 'enumerating-private' stamp: 'ThierryGoubier 6/25/2012 16:27'!
doRecords: records 
	"Fuse message send events and method entry, if appropriate."

	| rcs plv |
	rcs := super doRecords: records.
	plv := nil.
	rcs
		linksDo: 
			[:lv | | r |
			r := lv value.
			(plv notNil and: [plv value isMethod and: [plv value selector == r selector]])
				ifTrue: 
					[rcs remove: plv value.
					r children addFirst: plv].
			plv := lv].
	^rcs! !

!JRecordVisiteur class methodsFor: 'instance creation' stamp: ''!
do: anAbstractItem
	^self new do: anAbstractItem! !

!JRecordVisiteur class methodsFor: 'resources' stamp: ''!
menuLabel
	^'visit...'! !

!JRecordVisiteur methodsFor: 'accessing' stamp: ''!
do: anAbstractRecord
	"start the visit on the first record item. Returns true or false to indicate
	changes to the subtree."

	self doRecord: anAbstractRecord.
	^false! !

!JRecordVisiteur methodsFor: 'enumerating' stamp: ''!
doAssignment: aRecord
	"Do an assignment node."

	^aRecord! !

!JRecordVisiteur methodsFor: 'enumerating' stamp: ''!
doBlock: aRecord
	"Do an block node."

	^aRecord setChildren: (self doRecords: aRecord children)! !

!JRecordVisiteur methodsFor: 'enumerating' stamp: ''!
doItem: aRecord
	"Do an item node."

	^aRecord setChildren: (self doRecords: aRecord children)! !

!JRecordVisiteur methodsFor: 'enumerating' stamp: ''!
doMethod: aRecord
	^aRecord setChildren: (self doRecords: aRecord children)! !

!JRecordVisiteur methodsFor: 'enumerating-private' stamp: ''!
doRecord: aRecord
	^aRecord recordDo: self! !

!JRecordVisiteur methodsFor: 'enumerating-private' stamp: 'ThierryGoubier 6/25/2012 16:15'!
doRecords: records
	^records collect: [:n | self doRecord: n]! !

!JRecordVisiteur methodsFor: 'enumerating' stamp: ''!
doVariable: aRecord
	"Do an assignment node."

	^aRecord! !

JRecordVisiteur subclass: #JTypeFilter
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JTypeFilter commentStamp: '<historical>' prior: 0!
RVTypeFilter filters variables and values based on their type; it contains a target type and remove all the items which do not belong to it.

Instance Variables:
	type	<Object>	The type to filter the trace tree against

!

!JTypeFilter class methodsFor: 'resources' stamp: ''!
menuLabel
	^'filter on type...'! !

!JTypeFilter methodsFor: 'accessing' stamp: 'ThierryGoubier 7/18/2012 14:33'!
do: aRV
	"Iterate starting at a RV."

	| aClass |
	aClass := ClassSearch chooseFromOwner: World.
	aClass notNil ifFalse: [^self].
	self setType: aClass.
	super do: aRV.
	^true! !

!JTypeFilter methodsFor: 'enumerating' stamp: ''!
doAssignment: aRecord
	"An assignment has a value, hence a type."

	^(aRecord value isKindOf: type)
		ifTrue: [aRecord]
		ifFalse: [nil]! !

!JTypeFilter methodsFor: 'enumerating' stamp: ''!
doBlock: aRecord
	| ns |
	ns := (super doBlock: aRecord) reject: [:n | n isNil].
	^ns isEmpty
		ifFalse: [aRecord copy setChildren: ns]
		ifTrue: [nil]! !

!JTypeFilter methodsFor: 'enumerating' stamp: ''!
doItem: aRecord
	| ns |
	ns := (super doItem: aRecord) reject: [:n | n isNil].
	^ns isEmpty
		ifFalse: [aRecord copy setChildren: ns]
		ifTrue: [nil]! !

!JTypeFilter methodsFor: 'enumerating' stamp: ''!
doMethod: aRecord
	| ns |
	ns := (super doItem: aRecord) reject: [:n | n isNil].
	^ns isEmpty
		ifFalse: [aRecord copy setChildren: ns]
		ifTrue: [nil]! !

!JTypeFilter methodsFor: 'enumerating' stamp: ''!
doVariable: aRecord
	"Not interested in tracking variable declaration."

	^nil! !

!JTypeFilter methodsFor: 'private' stamp: ''!
setGF: aGF
	type := aGF! !

!JTypeFilter methodsFor: 'private' stamp: ''!
setType: aClass
	type := aClass! !

Object subclass: #JRecorder
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JRecorder commentStamp: '<historical>' prior: 0!
TraceRecorder is an object building a trace tree based on events sent to it. The events are expected to be generated by probes, and the trace tree is built out of AbstractRecord instances.

Instance Variables:
	stack	<(OrderedCollection of: AbstractRecord)>	It contains the current path in the trace tree. The current item events are added to is the last item of the stack. The first item of the stack is a special node: root, or the root of the tree

!

!JRecorder class methodsFor: 'instance creation' stamp: ''!
new
	^super new initialize! !

!JRecorder methodsFor: 'private' stamp: 'ThierryGoubier 6/24/2012 22:19'!
addChild: aRecord
	self current addChild: aRecord! !

!JRecorder methodsFor: 'execution graph' stamp: 'ThierryGoubier 7/18/2012 10:06'!
assign: aValue to: aVar named: aName at: anIndex node: n
	self addChild: (JRecordAssignment new 
				var: aName , '[' , anIndex printString , ']'
				node: n
				value: aValue copy).
	^aVar at: anIndex put: aValue! !

!JRecorder methodsFor: 'execution graph' stamp: 'ThierryGoubier 7/18/2012 10:06'!
assign: aValue to: aVar node: n 
	self addChild: (JRecordAssignment new 
				var: aVar
				node: n
				value: aValue copy).
	^aValue! !

!JRecorder methodsFor: 'accessing' stamp: ''!
current
	^stack last! !

!JRecorder methodsFor: 'execution graph' stamp: 'ThierryGoubier 7/18/2012 10:06'!
define: vars node: n
	self addChild: (JRecordVariable new 
				var: vars
				node: n)! !

!JRecorder methodsFor: 'accessing' stamp: ''!
elements
	^stack first children! !

!JRecorder methodsFor: 'execution graph' stamp: 'ThierryGoubier 7/18/2012 10:05'!
enter: nid
	"we are going into a loop or into an ifTrue: or ifFalse:"

	| n |
	n := JRecordBlock new 
				node: nid.
	self addChild: n.
	stack addLast: n! !

!JRecorder methodsFor: 'execution graph' stamp: 'ThierryGoubier 7/18/2012 10:06'!
enter: object selector: sel node: nid
	"we are going into a method. Add a level."

	| n |
	n := JRecordMethod new 
				object: object copy
				selector: sel
				node: nid.
	self addChild: n.
	stack addLast: n! !

!JRecorder methodsFor: 'execution graph' stamp: ''!
exit: aValue
	"going out of a level, with a returned value."

	stack removeLast.
	^aValue! !

!JRecorder methodsFor: 'execution graph' stamp: ''!
exitLevel
	"going out of a level."

	stack size > 1 ifTrue: [stack removeLast]! !

!JRecorder methodsFor: 'initialize-release' stamp: 'ThierryGoubier 7/18/2012 10:05'!
initialize
	stack := OrderedCollection new.
	stack add: (JRecordItem new selector: #root node: 0)! !

!JRecorder methodsFor: 'printing' stamp: ''!
oldPrintOn: aStream 
	| indent b |
	indent := ''.
	b := 
			[:a | 
			a hasChildren 
				ifTrue: 
					[aStream
						nextPutAll: indent , a printString;
						cr.
					indent := indent , '    '.
					a children do: [:el | b value: el value].
					indent := indent copyFrom: 1 to: indent size - 4]
				ifFalse: 
					[aStream
						nextPutAll: indent , a printString;
						cr]].
	b value: stack first! !

!JRecorder methodsFor: 'execution graph' stamp: 'ThierryGoubier 7/18/2012 10:05'!
record: aSelector node: n 
	"Record a selector with it's source position, to relate to the original source in a browser."

	| r |
	r := JRecordItem new selector: aSelector node: n.
	self addChild: r.
	^aSelector! !

!JRecorder methodsFor: 'execution graph' stamp: 'ThierryGoubier 7/18/2012 10:05'!
record: aSelector node: n value: v
	"Record a selector with it's source position, to relate to the original source in a browser."

	| r |
	r := JRecordItem new selector: aSelector node: n.
	self addChild: r.
	^v! !

!JRecorder methodsFor: 'initialize-release' stamp: ''!
reset
	stack first setChildren: nil.
	[stack size > 1] whileTrue: [stack removeLast]! !

!JRecorder methodsFor: 'execution graph' stamp: ''!
return: aValue 
	[stack removeLast isMethod] whileFalse: [].
	^aValue! !

!JRecorder methodsFor: 'execution graph' stamp: 'ThierryGoubier 7/18/2012 10:06'!
return: aValue node: n 
	self addChild: (JRecordAssignment new 
				var: 'return'
				node: n
				value: aValue copy).
	[stack removeLast isMethod] whileFalse: [].
	^aValue! !

!JRecorder methodsFor: 'accessing' stamp: ''!
stack
	^stack! !

!JRecorder methodsFor: 'printing' stamp: 'ThierryGoubier 7/18/2012 10:06'!
storeOn: aStream
	#JCollecteur storeOn: aStream! !

JRecorder subclass: #JThreadedRecorder
	instanceVariableNames: 'process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak'!

!JThreadedRecorder commentStamp: '<historical>' prior: 0!
ThreadedRecorder record trace events and notices changes in context when recording an event, allowing trace of multi-process algorithms.

Instance Variables:
	process	<a Process>	the current context's process, to be checked against when recording an event, to be able to notice a context switch.

!

!JThreadedRecorder methodsFor: 'execution graph' stamp: 'ThierryGoubier 7/18/2012 10:05'!
context: nid
	"Do add a level if we enter a process; exit a level too."

	process == Processor activeProcess 
		ifFalse: 
			[| n |
			self exitLevel.
			process := Processor activeProcess.
			n := JRecordItem new selector: 'Context Switch' node: nid.
			self current addChild: n.
			stack addLast: n]! !

!JThreadedRecorder methodsFor: 'execution graph' stamp: 'ThierryGoubier 7/18/2012 10:06'!
enter: object selector: sel node: nid
	"we are going into a method. Add a level."

	| n |
	n := JRecordMethod new 
				object: object copy
				selector: sel
				node: nid.
	self current addChild: n.
	stack addLast: n.
	self context: nid.! !

!JThreadedRecorder methodsFor: 'execution graph' stamp: 'ThierryGoubier 7/18/2012 10:05'!
record: aSelector node: n
	"Record a selector with it's source position, to relate to the original source in a browser."

	| r |
	self context: n.
	r := JRecordItem new 
				selector: aSelector
				node: n.
	self current children isEmpty 
		ifFalse: 
			[(self current children last isMethod 
				and: [self current children last selector == r selector]) 
					ifTrue: 
						[| t |
						t := self current children removeLast.
						r children add: t]].
	self current children add: r! !

!JThreadedRecorder methodsFor: 'initialize-release' stamp: ''!
reset
	stack first setChildren: nil.
	[stack size > 1] whileTrue: [stack removeLast].
	process := nil! !
JCollecteur initialize!
